Validation

Bootstrap 5 Validation

Provide valuable, actionable feedback to your users with HTML5 form validation, via browser default behaviors or custom styles and JavaScript.

Note: We currently recommend using custom validation styles, as native browser default validation messages are not consistently exposed to assistive technologies in all browsers (most notably, Chrome on desktop and mobile).


Basic example

For custom MDB form validation messages, you’ll need to add the novalidate boolean attribute to your <form>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript. Try to submit the form below; our JavaScript will intercept the submit button and relay feedback to you. When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Custom feedback styles apply custom colors, borders, focus styles, and background icons to better communicate feedback.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
          <form class="row g-3 needs-validation" novalidate>
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationCustom01" value="Mark" required />
                <label for="validationCustom01" class="form-label">First name</label>
                <div class="valid-feedback">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationCustom02" value="Otto" required />
                <label for="validationCustom02" class="form-label">Last name</label>
                <div class="valid-feedback">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="input-group form-outline" data-mdb-input-init>
                <span class="input-group-text" id="inputGroupPrepend">@</span>
                <input type="text" class="form-control" id="validationCustomUsername" aria-describedby="inputGroupPrepend" required />
                <label for="validationCustomUsername" class="form-label">Username</label>
                <div class="invalid-feedback">Please choose a username.</div>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationCustom03" required />
                <label for="validationCustom03" class="form-label">City</label>
                <div class="invalid-feedback">Please provide a valid city.</div>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationCustom05" required />
                <label for="validationCustom05" class="form-label">Zip</label>
                <div class="invalid-feedback">Please provide a valid zip.</div>
              </div>
            </div>
            <div class="col-12">
              <div class="form-check">
                <input class="form-check-input" type="checkbox" value="" id="invalidCheck" required />
                <label class="form-check-label" for="invalidCheck">Agree to terms and conditions</label>
                <div class="invalid-feedback">You must agree before submitting.</div>
              </div>
            </div>
            <div class="col-12">
              <button class="btn btn-primary" type="submit" data-mdb-ripple-init>Submit form</button>
            </div>
          </form>
        
        
    
        
            
          // Example starter JavaScript for disabling form submissions if there are invalid fields
          import { Input, Ripple, initMDB } from "mdb-ui-kit";

          initMDB({ Input, Ripple });

          (() => {
            'use strict';

            // Fetch all the forms we want to apply custom Bootstrap validation styles to
            const forms = document.querySelectorAll('.needs-validation');

            // Loop over them and prevent submission
            Array.prototype.slice.call(forms).forEach((form) => {
              form.addEventListener('submit', (event) => {
                if (!form.checkValidity()) {
                  event.preventDefault();
                  event.stopPropagation();
                }
                form.classList.add('was-validated');
              }, false);
            });
          })();
        
        
    
        
            
         // Example starter JavaScript for disabling form submissions if there are invalid fields
         (() => {
           'use strict';

           // Fetch all the forms we want to apply custom Bootstrap validation styles to
           const forms = document.querySelectorAll('.needs-validation');

           // Loop over them and prevent submission
           Array.prototype.slice.call(forms).forEach((form) => {
             form.addEventListener('submit', (event) => {
               if (!form.checkValidity()) {
                 event.preventDefault();
                 event.stopPropagation();
               }
               form.classList.add('was-validated');
             }, false);
           });
         })();
       
        
    

How it works

Here’s how form validation works with MDB:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <input> and <textarea> elements.
  • MDB scopes the :invalid and :valid styles to parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid on page load. This way, you may choose when to activate them (typically after form submission is attempted).
  • To reset the appearance of the form (for instance, in the case of dynamic form submissions using AJAX), remove the .was-validated class from the <form> again after submission.
  • As a fallback, .is-invalid and .is-valid classes may be used instead of the pseudo-classes for server-side validation. They do not require a .was-validated parent class.
  • Due to constraints in how CSS works, we cannot (at present) apply styles to a <label> that comes before a form control in the DOM without the help of custom JavaScript.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles with additional HTML and CSS.
  • You may provide custom validity messages with setCustomValidity in JavaScript.

With that in mind, consider the following demos for our custom form validation styles, optional server-side classes, and browser defaults.


Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? All good, you can use the browser defaults. Try submitting the form below. Depending on your browser and OS, you’ll see a slightly different style of feedback.

While these feedback styles cannot be styled with CSS, you can still customize the feedback text through JavaScript.

@
        
            
          <form class="row g-3">
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationDefault01" value="Mark" required />
                <label for="validationDefault01" class="form-label">First name</label>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationDefault02" value="Otto" required />
                <label for="validationDefault02" class="form-label">Last name</label>
              </div>
            </div>
            <div class="col-md-4">
              <div class="input-group form-outline" data-mdb-input-init>
                <span class="input-group-text" id="inputGroupPrepend2">@</span>
                <input type="text" class="form-control" id="validationDefaultUsername" aria-describedby="inputGroupPrepend2" required />
                <label for="validationDefaultUsername" class="form-label">Username</label>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationDefault03" required />
                <label for="validationDefault03" class="form-label">City</label>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationDefault05" required />
                <label for="validationDefault05" class="form-label">Zip</label>
              </div>
            </div>
            <div class="col-12">
              <div class="form-check">
                <input class="form-check-input" type="checkbox" value="" id="invalidCheck2" required />
                <label class="form-check-label" for="invalidCheck2">Agree to terms and conditions</label>
              </div>
            </div>
            <div class="col-12">
              <button class="btn btn-primary" type="submit" data-mdb-ripple-init>Submit form</button>
            </div>
          </form>
        
        
    
        
            
          // Initialization for ES Users
          import { Input, Ripple, initMDB } from "mdb-ui-kit";

          initMDB({ Input, Ripple });
        
        
    

Server side

We recommend using client-side validation, but in case you require server-side validation, you can indicate invalid and valid form fields with .is-invalid and .is-valid. Note that .invalid-feedback is also supported with these classes.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
          <form class="row g-4">
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control is-valid" id="validationServer01" value="Mark" required />
                <label for="validationServer01" class="form-label">First name</label>
                <div class="valid-feedback">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control is-valid" id="validationServer02" value="Otto" required />
                <label for="validationServer02" class="form-label">Last name</label>
                <div class="valid-feedback">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="input-group form-outline" data-mdb-input-init>
                <span class="input-group-text" id="inputGroupPrepend3">@</span>
                <input 
                  type="text"
                  class="form-control is-invalid"
                  id="validationServerUsername"
                  aria-describedby="inputGroupPrepend3"
                  required
                />
                <label for="validationServerUsername" class="form-label">Username</label>
                <div class="invalid-feedback">Please choose a username.</div>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control is-invalid" id="validationServer03" required />
                <label for="validationServer03" class="form-label">City</label>
                <div class="invalid-feedback">Please provide a valid city.</div>
              </div>
            </div>
            <div class="col-md-6">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control is-invalid" id="validationServer05" required />
                <label for="validationServer05" class="form-label">Zip</label>
                <div class="invalid-feedback">Please provide a valid zip.</div>
              </div>
            </div>
            <div class="col-12">
              <div class="form-check">
                <input class="form-check-input is-invalid" type="checkbox" value="" id="invalidCheck3" required />
                <label class="form-check-label" for="invalidCheck3">Agree to terms and conditions</label>
                <div class="invalid-feedback">You must agree before submitting.</div>
              </div>
            </div>
            <div class="col-12">
              <button class="btn btn-primary" type="submit" data-mdb-ripple-init>Submit form</button>
            </div>
          </form>
        
        
    
        
            
          // Initialization for ES Users
          import { Input, Ripple, initMDB } from "mdb-ui-kit";

          initMDB({ Input, Ripple });
        
        
    

Supported elements

Validation styles are available for the following form controls and components:

  • <input>s and <textarea>s with .form-control (including up to one .form-control in input groups)
  • .form-checks
Please enter a message in the textarea.
Example invalid feedback text
More example invalid feedback text
Example invalid form file feedback
        
            
          <form class="was-validated">
            <div class="mb-3 pb-1">
              <div class="form-outline" data-mdb-input-init>
                <textarea class="form-control is-valid" id="validationTextarea" placeholder="Required example textarea" required></textarea>
                <label for="validationTextarea" class="form-label">Textarea</label>
                <div class="invalid-feedback">Please enter a message in the textarea.</div>
              </div>
            </div>
            <div class="form-check mb-3">
              <input type="checkbox" class="form-check-input" id="validationFormCheck1" required />
              <label class="form-check-label" for="validationFormCheck1">Check this checkbox</label>
              <div class="invalid-feedback">Example invalid feedback text</div>
            </div>
            <div class="form-check">
              <input type="radio" class="form-check-input" id="validationFormCheck2" name="radio-stacked" required />
              <label class="form-check-label" for="validationFormCheck2">Toggle this radio</label>
            </div>
            <div class="form-check mb-3">
              <input type="radio" class="form-check-input" id="validationFormCheck3" name="radio-stacked" required />
              <label class="form-check-label" for="validationFormCheck3">Or toggle this other radio</label>
              <div class="invalid-feedback">More example invalid feedback text</div>
            </div>
            <div class="mb-3">
              <input type="file" class="form-control" aria-label="file example" required />
              <div class="invalid-feedback">Example invalid form file feedback</div>
            </div>
            <div class="mb-3">
              <button class="btn btn-primary" type="submit" disabled data-mdb-ripple-init>Submit form</button>
            </div>
          </form>
        
        
    
        
            
          // Initialization for ES Users
          import { Input, Ripple, initMDB } from "mdb-ui-kit";

          initMDB({ Input, Ripple });
        
        
    

Tooltips

If your form layout allows it, you can swap the .{valid|invalid}-feedback classes for .{valid|invalid}-tooltip classes to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative on it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Looks good!
Looks good!
@
Please choose a unique and valid username.
Please provide a valid city.
Please provide a valid zip.
        
            
          <form class="row g-3 needs-validation" novalidate>
            <div class="col-md-4 position-relative">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationTooltip01" value="Mark" required />
                <label for="validationTooltip01" class="form-label">First name</label>
                <div class="valid-tooltip">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4 position-relative">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationTooltip02" value="Otto" required />
                <label for="validationTooltip02" class="form-label">Last name</label>
                <div class="valid-tooltip">Looks good!</div>
              </div>
            </div>
            <div class="col-md-4 position-relative">
              <div class="input-group form-outline" data-mdb-input-init>
                <span class="input-group-text" id="validationTooltipUsernamePrepend">@</span>
                <input
                  type="text"
                  class="form-control"
                  id="validationTooltipUsername"
                  aria-describedby="validationTooltipUsernamePrepend"
                  required
                />
                <label for="validationTooltipUsername" class="form-label">Username</label>
                <div class="invalid-tooltip">Please choose a unique and valid username.</div>
              </div>
            </div>
            <div class="col-md-6 position-relative">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationTooltip03" required />
                <label for="validationTooltip03" class="form-label">City</label>
                <div class="invalid-tooltip">Please provide a valid city.</div>
              </div>
            </div>
            <div class="col-md-6 position-relative">
              <div class="form-outline" data-mdb-input-init>
                <input type="text" class="form-control" id="validationTooltip05" required />
                <label for="validationTooltip05" class="form-label">Zip</label>
                <div class="invalid-tooltip">Please provide a valid zip.</div>
              </div>
            </div>
            <div class="col-12 pt-2">
              <button class="btn btn-primary" type="submit" data-mdb-ripple-init>Submit form</button>
            </div>
          </form>
        
        
    
        
            
          // Initialization for ES Users
          import { Input, Ripple, initMDB } from "mdb-ui-kit";

          initMDB({ Input, Ripple });
        
        
    

Customizing

Validation states can be customized via Sass with the $form-validation-states map. Located in our _variables.scss file, this Sass map is looped over to generate the default valid/invalid validation states. Included is a nested map for customizing each state’s color. While no other states are supported by browsers, those using custom styles can easily add more complex form feedback.

Please note that we do not recommend customizing these values without also modifying the form-validation-state mixin.

This is the Sass map from _variables.scss. Override this and recompile your Sass to generate different states:

        
            
          $form-validation-states: (
            'valid': (
              'color': $form-feedback-valid-color,
              'icon': $form-feedback-icon-valid,
              'tooltip-color': #fff,
              'tooltip-bg-color': var(--#{$prefix}success),
              'focus-box-shadow': 0 0 $input-btn-focus-blur $input-focus-width
                rgba(var(--#{$prefix}success-rgb), $input-btn-focus-color-opacity),
              'border-color': var(--#{$prefix}form-valid-border-color),
            ),
            'invalid': (
              'color': $form-feedback-invalid-color,
              'icon': $form-feedback-icon-invalid,
              'tooltip-color': #fff,
              'tooltip-bg-color': var(--#{$prefix}danger),
              'focus-box-shadow': 0 0 $input-btn-focus-blur $input-focus-width
                rgba(var(--#{$prefix}danger-rgb), $input-btn-focus-color-opacity),
              'border-color': var(--#{$prefix}form-invalid-border-color),
            ),
          );
        
        
    

This is the loop from forms/_validation.scss. Any modifications to the above Sass map will be reflected in your compiled CSS via this loop:

        
            
          @each $state, $data in $form-validation-states { 
            @include form-validation-state(
              $state, 
              map-get($data, color),
              map-get($data, icon)
            ); 
          }
        
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Validation

Vue Bootstrap 5 Validation

Provide valuable, actionable feedback to your users with Vue form validation, via browser default behaviors or custom styles and JavaScript.

Note: We currently recommend using custom validation styles, as native browser default validation messages are not consistently exposed to assistive technologies in all browsers (most notably, Chrome on desktop and mobile).


Basic example

For custom MDB form validation messages, you’ll need to add the novalidate boolean attribute to your <form>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript. Try to submit the form below; our JavaScript will intercept the submit button and relay feedback to you. When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Custom feedback styles apply custom colors, borders, focus styles, and background icons to better communicate feedback.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
            <template>
              <MDBRow tag="form" class="g-3 needs-validation" novalidate @submit.prevent="checkForm">
                <MDBCol md="4">
                  <MDBInput
                    label="First name"
                    v-model="input1"
                    invalidFeedback="Please provide your first name"
                    validFeedback="Looks good!"
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    label="Last name"
                    v-model="input2"
                    invalidFeedback="Please provide your last name"
                    validFeedback="Looks good!"
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    inputGroup
                    aria-label="Username"
                    aria-describedby="basic-addon1"
                    placeholder="Username"
                    v-model="input3"
                    invalidFeedback="Please choose a username."
                    validFeedback="Looks good!"
                    required
                  >
                    <template v-slot:prepend>
                      <span class="input-group-text" id="basic-addon1">@</span>
                    </template></MDBInput
                  >
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="City"
                    v-model="input4"
                    invalidFeedback="Please provide a valid city."
                    validFeedback="Looks good!"
                    required
                  />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="Zip"
                    v-model="input5"
                    invalidFeedback="Please provide a valid zip."
                    validFeedback="Looks good!"
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBCheckbox
                    label="Agree to terms and conditions"
                    v-model="checkbox1"
                    invalidFeedback="You must agree before submitting."
                    validFeedback="Looks good!"
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBCol,
                  MDBRow,
                  MDBInput,
                  MDBCheckbox,
                  MDBBtn
                },
                setup() {
                  const checkForm = e => {
                    e.target.classList.add("was-validated");
                  };
                  const input1 = ref("Mark");
                  const input2 = ref("Otto");
                  const input3 = ref("");
                  const input4 = ref("");
                  const input5 = ref("");
                  const checkbox1 = ref(false);

                  return {
                    input1,
                    input2,
                    input3,
                    input4,
                    input5,
                    checkbox1,
                    checkForm
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const checkForm = (event: Event) => {
                event.target.classList.add("was-validated");
              };
              const input1 = ref("Mark");
              const input2 = ref("Otto");
              const input3 = ref("");
              const input4 = ref("");
              const input5 = ref("");
              const checkbox1 = ref(false);
            </script>
          
        
    

How it works

Note: Our validation can be used together with packages specializing in form validation. Check out this tutorial to see how to painlessly integrate MDB Vue with VeeValidate.

Here’s how form validation works with MDB:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <MDBInput> and <MDBTextarea> elements.
  • MDB scopes the :invalid and :valid styles to parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid on page load. This way, you may choose when to activate them (typically after form submission is attempted).
  • To reset the appearance of the form (for instance, in the case of dynamic form submissions using AJAX), remove the .was-validated class from the <form> again after submission.
  • As a fallback, isValid and isValidated properties may be used on validated components instead of the pseudo-classes for server-side validation. They do not require a .was-validated parent class.
  • Due to constraints in how CSS works, we cannot (at present) apply styles to a <label> that comes before a form control in the DOM without the help of custom JavaScript.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles with additional HTML and CSS.
  • You may provide custom validity messages with validFeedback and invalidFeedback properties for validated components.

With that in mind, consider the following demos for our custom form validation styles, optional server-side classes, and browser defaults.


Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? All good, you can use the browser defaults. Try submitting the form below. Depending on your browser and OS, you’ll see a slightly different style of feedback.

While these feedback styles cannot be styled with CSS, you can still customize the feedback text through JavaScript.

@
        
            
            <template>
              <MDBRow tag="form" class="g-3">
                <MDBCol md="4">
                  <MDBInput label="First name" v-model="input6" required />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput label="Last name" v-model="input7" required />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    inputGroup
                    aria-label="Username"
                    aria-describedby="basic-addon2"
                    v-model="input8"
                    required
                  >
                    <template v-slot:prepend>
                      <span class="input-group-text" id="basic-addon2">@</span>
                    </template>
                  </MDBInput>
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput label="City" v-model="input9" required />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput label="Zip" v-model="input10" required />
                </MDBCol>
                <MDBCol col="12">
                  <MDBCheckbox label="Agree to terms and conditions" v-model="checkbox2" required />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              export default {
                components: {
                  MDBCol,
                  MDBRow,
                  MDBInput,
                  MDBCheckbox,
                  MDBBtn,
                },
                setup() {
                  const input6 = ref('Mark');
                  const input7 = ref('Otto');
                  const input8 = ref('');
                  const input9 = ref('');
                  const input10 = ref('');
                  const checkbox2 = ref(false);

                  return {
                    input6,
                    input7,
                    input8,
                    input9,
                    input10,
                    checkbox2,
                  };
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              const input6 = ref('Mark');
              const input7 = ref('Otto');
              const input8 = ref('');
              const input9 = ref('');
              const input10 = ref('');
              const checkbox2 = ref(false);
            </script>
          
        
    

Server side

We recommend using client-side validation, but in case you require server-side validation, you can indicate invalid and valid form fields with isValid and isValidated properties. Note that invalidFeedback and validFeedback are also supported with these properties.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
            <template>
              <MDBRow tag="form" class="g-3">
                <MDBCol md="4">
                  <MDBInput
                    label="First name"
                    v-model="input11"
                    invalidFeedback="Please provide your first name"
                    validFeedback="Looks good!"
                    isValid
                    isValidated
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    label="Last name"
                    v-model="input12"
                    invalidFeedback="Please provide your last name"
                    validFeedback="Looks good!"
                    isValid
                    isValidated
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    inputGroup
                    aria-describedby="basic-addon3"
                    aria-label="Username"
                    placeholder="Username"
                    v-model="input13"
                    invalidFeedback="Please choose a unique and valid username."
                    validFeedback="Looks good!"
                    :isValid="false"
                    isValidated
                    required
                  >
                    <template v-slot:prepend>
                      <span class="input-group-text" id="basic-addon3">@</span>
                    </template>
                  </MDBInput>
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="City"
                    v-model="input14"
                    invalidFeedback="Please provide a valid city."
                    validFeedback="Looks good!"
                    :isValid="false"
                    isValidated
                    required
                  />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="Zip"
                    v-model="input15"
                    invalidFeedback="Please provide a valid zip."
                    validFeedback="Looks good!"
                    :isValid="false"
                    isValidated
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBCheckbox
                    label="Agree to terms and conditions"
                    v-model="checkbox3"
                    invalidFeedback="You must agree before submitting."
                    validFeedback="Looks good!"
                    :isValid="false"
                    isValidated
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              export default {
                components: {
                  MDBCol,
                  MDBRow,
                  MDBInput,
                  MDBCheckbox,
                  MDBBtn,
                },
                setup() {
                  const input11 = ref('Mark');
                  const input12 = ref('Otto');
                  const input13 = ref('');
                  const input14 = ref('');
                  const input15 = ref('');
                  const checkbox3 = ref(false);

                  return {
                    input11,
                    input12,
                    input13,
                    input14,
                    input15,
                    checkbox3,
                  };
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBCol, MDBRow, MDBInput, MDBCheckbox, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              const input11 = ref('Mark');
              const input12 = ref('Otto');
              const input13 = ref('');
              const input14 = ref('');
              const input15 = ref('');
              const checkbox3 = ref(false);
            </script>
          
        
    

Supported elements

Validation styles are available for the following form controls and components:

Please enter a message in the textarea.
Example invalid feedback text
More example invalid feedback text
Example invalid form file feedback
        
            
            <template>
              <form class="was-validated">
                <div class="mb-3 pb-1">
                  <MDBTextarea
                    label="Textarea"
                    rows="4"
                    v-model="textarea1"
                    required
                    invalidFeedback="Please enter a message in the textarea"
                  />
                </div>
                <MDBCheckbox
                  label="Check this checkbox"
                  v-model="checkbox4"
                  invalidFeedback="Example invalid feedback text"
                  validFeedback="Looks good!"
                  required
                  wrapperClass="mb-3"
                />
                <MDBRadio
                  label="Toggle this radio"
                  name="radio-stacked"
                  v-model="radio1"
                  value="value1"
                  required
                />
                <MDBRadio
                  label="Or toggle this other radio"
                  name="radio-stacked"
                  v-model="radio2"
                  value="value2"
                  required
                  invalidFeedback="More example invalid feedback text"
                  wrapperClass="mb-3"
                />
                <div class="mb-5">
                  <MDBInput
                    :formOutline="false"
                    type="file"
                    v-model="input16"
                    invalidFeedback="Example invalid form file feedback"
                    required
                  />
                </div>
                <div>
                  <MDBBtn color="primary" type="submit" disabled> Submit form </MDBBtn>
                </div>
              </form>
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBCheckbox, MDBRadio, MDBTextarea, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              export default {
                components: {
                  MDBInput,
                  MDBCheckbox,
                  MDBRadio,
                  MDBTextarea,
                  MDBBtn,
                },
                setup() {
                  const textarea1 = ref('');
                  const checkbox4 = ref(false);
                  const radio1 = ref('radio1');
                  const radio2 = ref('radio2');
                  const input16 = ref('');

                  return {
                    textarea1,
                    checkbox4,
                    radio1,
                    radio2,
                    input16,
                  };
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBCheckbox, MDBRadio, MDBTextarea, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              const textarea1 = ref('');
              const checkbox4 = ref(false);
              const radio1 = ref('radio1');
              const radio2 = ref('radio2');
              const input16 = ref('');
            </script>
          
        
    

Tooltips

If your form layout allows it, you can add tooltipFeedback property for validFeedback, invalidFeedback properties to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative on it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Looks good!
Looks good!
@
Please choose a unique and valid username.
Please provide a valid city.
Please provide a valid zip.
        
            
            <template>
              <MDBRow tag="form" class="g-3 needs-validation" novalidate @submit.prevent="checkForm">
                <MDBCol md="4">
                  <MDBInput
                    label="First name"
                    v-model="input17"
                    invalidFeedback="Please provide your first name"
                    validFeedback="Looks good!"
                    tooltipFeedback
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    label="Last name"
                    v-model="input18"
                    invalidFeedback="Please provide your last name"
                    validFeedback="Looks good!"
                    tooltipFeedback
                    required
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    inputGroup
                    aria-describedby="basic-addon4"
                    aria-label="Username"
                    placeholder="Username"
                    v-model="input19"
                    invalidFeedback="Please choose a unique and valid username."
                    validFeedback="Looks good!"
                    tooltipFeedback
                    required
                  >
                    <template v-slot:prepend>
                      <span class="input-group-text" id="basic-addon4">@</span>
                    </template>
                  </MDBInput>
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="City"
                    v-model="input20"
                    invalidFeedback="Please provide a valid city."
                    validFeedback="Looks good!"
                    tooltipFeedback
                    required
                  />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="Zip"
                    v-model="input21"
                    invalidFeedback="Please provide a valid zip."
                    validFeedback="Looks good!"
                    tooltipFeedback
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBCol, MDBRow, MDBInput, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              export default {
                components: {
                  MDBCol,
                  MDBRow,
                  MDBInput,
                  MDBBtn,
                },
                setup() {
                  const checkForm = (event) => {
                    event.target.classList.add('was-validated');
                  };
                  const input17 = ref('Mark');
                  const input18 = ref('Otto');
                  const input19 = ref('');
                  const input20 = ref('');
                  const input21 = ref('');

                  return {
                    checkForm,
                    input17,
                    input18,
                    input19,
                    input20,
                    input21,
                  };
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBCol, MDBRow, MDBInput, MDBBtn } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              const checkForm = (event: Event) => {
                event.target.classList.add('was-validated');
              };
              const input17 = ref('Mark');
              const input18 = ref('Otto');
              const input19 = ref('');
              const input20 = ref('');
              const input21 = ref('');
            </script>
          
        
    

Validation on event

Use validationEvent="event name" property for input and textarea or validateOnChange property for checkbox and radio inputs to validate elements on specific event instead of submit.

Adding validation attributes to input element such as minLength or pattern will show validation message based on your default browser validation response for invalid element. Add proper information about validation requirements in title attribute for better accessibility.

Looks good!
Please provide your first name
Looks good!
Please provide your last name
@
Looks good!
Please choose a username.
Looks good!
Please provide a valid city.
Looks good!
Please provide a valid zip.
Looks good!
You must agree before submitting.
        
            
            <template>
              <MDBRow tag="form" class="g-3 needs-validation" novalidate @submit.prevent="checkForm">
                <MDBCol md="6">
                  <MDBInput
                    label="First name"
                    v-model="eventInput1"
                    invalidFeedback="Please provide your first name"
                    validFeedback="Looks good!"
                    validationEvent="input"
                    required
                    title="Must contain between 5 and 30 characters"
                    minLength="5"
                    maxLength="30"
                  />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="Last name"
                    v-model="eventInput2"
                    invalidFeedback="Please provide your last name"
                    validFeedback="Looks good!"
                    validationEvent="input"
                    required
                    title="Must contain between 5 and 30 characters"
                    minLength="5"
                    maxLength="30"
                  />
                </MDBCol>
                <MDBCol md="4">
                  <MDBInput
                    inputGroup
                    aria-describedby="basic-addon1"
                    aria-label="Username"
                    placeholder="Username"
                    v-model="eventInput3"
                    invalidFeedback="Please choose a unique and valid username."
                    validFeedback="Looks good!"
                    validationEvent="input"
                    required
                    pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{8,}"
                    title="Must contain at least one  number and one uppercase and lowercase letter, and at least 8 or more characters"
                  >
                    <template v-slot:prepend>
                      <span class="input-group-text" id="basic-addon5">@</span>
                    </template>
                  </MDBInput>
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="City"
                    v-model="eventInput4"
                    invalidFeedback="Please provide a valid city."
                    validFeedback="Looks good!"
                    validationEvent="input"
                    required
                  />
                </MDBCol>
                <MDBCol md="6">
                  <MDBInput
                    label="Zip"
                    v-model="eventInput5"
                    invalidFeedback="Please provide a valid zip."
                    validFeedback="Looks good!"
                    validationEvent="input"
                    required
                    pattern="^[0-9]{5}(?:-[0-9]{4})?$"
                    title="Should match 12345 and 12345-6789 patterns"
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBCheckbox
                    label="Agree to terms and conditions"
                    v-model="eventCheckbox1"
                    invalidFeedback="You must agree before submitting."
                    validFeedback="Looks good!"
                    validateOnChange
                    required
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBCol, MDBRow, MDBInput, MDBBtn, MDBCheckbox } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              export default {
                components: {
                  MDBCol,
                  MDBRow,
                  MDBInput,
                  MDBBtn,
                  MDBCheckbox,
                },
                setup() {
                  const checkForm = (event) => {
                    event.target.classList.add('was-validated');
                  };
                  const eventInput1 = ref('');
                  const eventInput2 = ref('');
                  const eventInput3 = ref('');
                  const eventInput4 = ref('');
                  const eventInput5 = ref('');
                  const eventCheckbox1 = ref(false);

                  return {
                    checkForm,
                    eventInput1,
                    eventInput2,
                    eventInput3,
                    eventInput4,
                    eventInput5,
                    eventCheckbox1,
                  };
                },
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBCol, MDBRow, MDBInput, MDBBtn, MDBCheckbox } from 'mdb-vue-ui-kit';
              import { ref } from 'vue';

              const checkForm = (event: Event) => {
                event.target.classList.add('was-validated');
              };
              const eventInput1 = ref('');
              const eventInput2 = ref('');
              const eventInput3 = ref('');
              const eventInput4 = ref('');
              const eventInput5 = ref('');
              const eventCheckbox1 = ref(false);
            </script>
          
        
    

Customizing

Validation states can be customized via Sass with the $form-validation-states map. Located in our _variables.scss file, this Sass map is looped over to generate the default valid/invalid validation states. Included is a nested map for customizing each state’s color. While no other states are supported by browsers, those using custom styles can easily add more complex form feedback.

Please note that we do not recommend customizing these values without also modifying the form-validation-state mixin.

This is the Sass map from _variables.scss. Override this and recompile your Sass to generate different states:

        
            
            $form-validation-states: ( 
              "valid": (
                "color": $form-feedback-valid-color,
                "icon":  $form-feedback-icon-valid 
              ),
              "invalid": (
                "color": $form-feedback-invalid-color,
                "icon":  $form-feedback-icon-invalid 
              )
            );
          
        
    

This is the loop from forms/_validation.scss. Any modifications to the above Sass map will be reflected in your compiled CSS via this loop:

        
            
            @each $state, $data in $form-validation-states { 
              @include form-validation-state(
                $state,
                map-get($data, color),
                map-get($data, icon)
              );
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Validation

Angular Bootstrap 5 Validation

Provide valuable, actionable feedback to your users with Angular form validation.


Basic example

Use mdbValidate directive to enable validation styles and mdb-error and mdb-success components to display validation messages.

Import ReactiveFormsModule to enable reactive forms validation in Angular.

Looks good!
First name is required
Looks good!
Last name is required
        
            
        <form [formGroup]="validationForm">
          <div class="row">
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form1"
                  class="form-control"
                  formControlName="firstName"
                  required
                />
                <label mdbLabel class="form-label" for="form1">First name</label>
                <mdb-error
                  *ngIf="
                      firstName?.invalid && (firstName?.dirty || firstName?.touched)
                      "
                  >First name is required</mdb-error
                >
                <mdb-success
                  *ngIf="
                      firstName?.valid && (firstName?.dirty || firstName?.touched)
                      "
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form2"
                  class="form-control"
                  formControlName="lastName"
                  required
                />
                <label mdbLabel class="form-label" for="form2">Last name</label>
                <mdb-error *ngIf="lastName?.invalid && (lastName?.dirty || lastName?.touched)"
                  >Last name is required</mdb-error
                >
                <mdb-success *ngIf="lastName?.valid && (lastName?.dirty || lastName?.touched)"
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
          </div>
        </form>
        
        
    
        
            
            import { Component } from '@angular/core';
            import { AbstractControl, FormControl, FormGroup, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              validationForm: FormGroup;

              constructor() {
                this.validationForm = new FormGroup({
                  firstName: new FormControl(null, Validators.required),
                  lastName: new FormControl(null, Validators.required),
                });
              }

              get firstName(): AbstractControl {
                return this.validationForm.get('firstName')!;
              }

              get lastName(): AbstractControl {
                return this.validationForm.get('lastName')!;
              }
            }
            
        
    

Supported elements

Validation styles are available for the following form controls and components:

  • <input>s and <textarea>s with .form-control (including up to one .form-control in input groups)
  • .form-checks
  • mdb-select
Input valid
Input invalid
Input valid
Input invalid
Input valid
Input invalid
        
            
        <form [formGroup]="validationForm">
          <div class="mb-3 pb-1">
            <mdb-form-control>
              <input
                mdbValidate
                mdbInput
                type="text"
                id="form1"
                class="form-control"
                formControlName="input"
                required
              />
              <label mdbLabel class="form-label" for="form1">Example label</label>
              <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)"
                >Input invalid</mdb-error
              >
              <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)"
                >Input valid</mdb-success
              >
            </mdb-form-control>
          </div>
          <div class="mb-3 pb-1">
            <mdb-form-control>
              <textarea
                mdbValidate
                mdbInput
                type="text"
                id="form1"
                class="form-control"
                formControlName="textarea"
                required
              ></textarea>
              <label mdbLabel class="form-label" for="form1">Example label</label>
              <mdb-error *ngIf="textarea?.invalid && (textarea?.dirty || textarea?.touched)"
                >Input invalid</mdb-error
              >
              <mdb-success *ngIf="textarea?.valid && (textarea?.dirty || textarea?.touched)"
                >Input valid</mdb-success
              >
            </mdb-form-control>
          </div>
          <div class="mb-3 pb-1">
            <mdb-form-control>
              <mdb-select mdbValidate [required]="true" formControlName="select">
                <mdb-option *ngFor="let option of options" [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
              <label mdbLabel class="form-label">Example label</label>
              <mdb-error *ngIf="select?.invalid && (select?.dirty || select?.touched)"
                >Input invalid</mdb-error
              >
              <mdb-success *ngIf="select?.valid && (select?.dirty || select?.touched)"
                >Input valid</mdb-success
              >
            </mdb-form-control>
          </div>
          <div class="form-check mt-5 mb-3 ms-2 pb-1">
            <input
              mdbValidate
              mdbCheckbox
              class="form-check-input"
              type="checkbox"
              value=""
              id="flexCheckDefault"
              formControlName="checkbox"
            />
            <label class="form-check-label" for="flexCheckDefault"> Default checkbox </label>
            <mdb-error *ngIf="checkbox?.invalid && (checkbox?.dirty || checkbox?.touched)"
              >Input invalid</mdb-error
            >
            <mdb-success *ngIf="checkbox?.valid && (checkbox?.dirty || checkbox?.touched)"
              >Input valid</mdb-success
            >
          </div>
        </form>
        
        
    
        
            
            import { Component } from '@angular/core';
            import { AbstractControl, FormControl, FormGroup, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              validationForm: FormGroup;

              options = [
                { value: '1', label: 'One' },
                { value: '2', label: 'Two' },
                { value: '3', label: 'Three' },
                { value: '4', label: 'Four' },
                { value: '5', label: 'Five' },
                { value: '6', label: 'Six' },
                { value: '7', label: 'Seven' },
                { value: '8', label: 'Eigth' },
              ];

              constructor() {
                this.validationForm = new FormGroup({
                  input: new FormControl(null, Validators.required),
                  textarea: new FormControl(null, Validators.required),
                  select: new FormControl(null, Validators.required),
                  checkbox: new FormControl(null, Validators.requiredTrue),
                });
              }

              get input(): AbstractControl {
                return this.validationForm.get('input')!;
              }

              get textarea(): AbstractControl {
                return this.validationForm.get('textarea')!;
              }

              get select(): AbstractControl {
                return this.validationForm.get('select')!;
              }

              get checkbox(): AbstractControl {
                return this.validationForm.get('checkbox')!;
              }
            }
            
        
    

On blur validation

Looks good!
First name is required
Looks good!
Last name is required
        
            
        <form [formGroup]="validationForm">
          <div class="row">
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form1"
                  class="form-control"
                  formControlName="firstName"
                  required
                />
                <label mdbLabel class="form-label" for="form1">First name</label>
                <mdb-error
                  *ngIf="
                      firstName?.invalid && (firstName?.dirty || firstName?.touched)
                      "
                  >First name is required</mdb-error
                >
                <mdb-success
                  *ngIf="
                      firstName?.valid && (firstName?.dirty || firstName?.touched)
                      "
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form2"
                  class="form-control"
                  formControlName="lastName"
                  required
                />
                <label mdbLabel class="form-label" for="form2">Last name</label>
                <mdb-error *ngIf="lastName?.invalid && (lastName?.dirty || lastName?.touched)"
                  >Last name is required</mdb-error
                >
                <mdb-success *ngIf="lastName?.valid && (lastName?.dirty || lastName?.touched)"
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
          </div>
        </form>
        
        
    
        
            
            import { Component } from '@angular/core';
            import { AbstractControl, FormControl, FormGroup, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              validationForm: FormGroup;

              constructor() {
                this.validationForm = new FormGroup({
                  firstName: new FormControl(null, Validators.required),
                  lastName: new FormControl(null, Validators.required),
                });
              }

              get firstName(): AbstractControl {
                return this.validationForm.get('firstName')!;
              }

              get lastName(): AbstractControl {
                return this.validationForm.get('lastName')!;
              }
            }
            
        
    

On submit validation

Looks good!
First name is required
Looks good!
Last name is required
        
            
        <form [formGroup]="validationForm" (ngSubmit)="onSubmit()">
          <div class="row">
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form1"
                  class="form-control"
                  formControlName="firstName"
                  required
                />
                <label mdbLabel class="form-label" for="form1">First name</label>
                <mdb-error
                  *ngIf="
                      firstName?.invalid && (firstName?.dirty || firstName?.touched)
                      "
                  >First name is required</mdb-error
                >
                <mdb-success
                  *ngIf="
                      firstName?.valid && (firstName?.dirty || firstName?.touched)
                      "
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
            <div class="col-md-6">
              <mdb-form-control>
                <input
                  mdbValidate
                  mdbInput
                  type="text"
                  id="form2"
                  class="form-control"
                  formControlName="lastName"
                  required
                />
                <label mdbLabel class="form-label" for="form2">Last name</label>
                <mdb-error *ngIf="lastName?.invalid && (lastName?.dirty || lastName?.touched)"
                  >Last name is required</mdb-error
                >
                <mdb-success *ngIf="lastName?.valid && (lastName?.dirty || lastName?.touched)"
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
            </div>
          </div>
          <button type="submit" class="btn btn-primary mt-4">Submit</button>
        </form>
        
        
    
        
            
            import { Component } from '@angular/core';
            import { AbstractControl, FormControl, FormGroup, Validators } from '@angular/forms';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              validationForm: FormGroup;

              constructor() {
                this.validationForm = new FormGroup({
                  firstName: new FormControl(null, { validators: Validators.required, updateOn: 'submit' }),
                  lastName: new FormControl(null, { validators: Validators.required, updateOn: 'submit' }),
                });
              }

              get firstName(): AbstractControl {
                return this.validationForm.get('firstName')!;
              }

              get lastName(): AbstractControl {
                return this.validationForm.get('lastName')!;
              }

              onSubmit(): void {
                this.validationForm.markAllAsTouched();
              }
            }
            
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Validation - API


Import

        
            
          import { MdbValidationModule } from 'mdb-angular-ui-kit/validation';
          import { ReactiveFormsModule } from '@angular/forms';
          …
          @NgModule ({
            ...
            imports: [MdbValidationModule, ReactiveFormsModule],
            ...
          })
        
        
    

Inputs

mdbValidate

Name Type Default Description
validateError boolean true Enables error validation.
validateSuccess boolean true Enables success validation.

Validation

React Bootstrap 5 Validation

Provide valuable, actionable feedback to your users with HTML5 form validation, via browser default behaviors or custom styles and JavaScript.

Note: We currently recommend using custom validation styles, as native browser default validation messages are not consistently exposed to assistive technologies in all browsers (most notably, Chrome on desktop and mobile).


Basic example

For custom MDB form validation messages, you’ll need to add the noValidate boolean prop to your <MDBValidation>. This disables the browser default feedback tooltips, but still provides access to the form validation APIs in JavaScript. Try to submit the form below; our JavaScript will intercept the submit button and relay feedback to you. When attempting to submit, you’ll see the :invalid and :valid styles applied to your form controls.

Custom feedback styles apply custom colors, borders, focus styles, and background icons to better communicate feedback.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
            import React, { useState } from 'react';
            import { 
              MDBValidation, 
              MDBValidationItem,
              MDBInput, 
              MDBInputGroup, 
              MDBBtn, 
              MDBCheckbox 
            } from 'mdb-react-ui-kit';
    
            export default function App() {
              const [formValue, setFormValue] = useState({
                fname: 'Mark',
                lname: 'Otto',
                email: '',
                city: '',
                state: '',
                zip: '',
              });
            
              const onChange = (e: any) => {
                setFormValue({ ...formValue, [e.target.name]: e.target.value });
              };

              return (
                <MDBValidation className='row g-3'>
                  <MDBValidationItem className='col-md-4'>
                    <MDBInput
                      value={formValue.fname}
                      name='fname'
                      onChange={onChange}
                      id='validationCustom01'
                      required
                      label='First name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-4'>
                    <MDBInput
                      value={formValue.lname}
                      name='lname'
                      onChange={onChange}
                      id='validationCustom02'
                      required
                      label='Last name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem feedback='Please choose a username.' invalid className='col-md-4'>
                    <MDBInputGroup textBefore='@'>
                      <input
                        type='text'
                        className='form-control'
                        id='validationCustomUsername'
                        placeholder='Username'
                        required
                      />
                    </MDBInputGroup>
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-6' feedback='Please provide a valid city.' invalid>
                    <MDBInput
                      value={formValue.city}
                      name='city'
                      onChange={onChange}
                      id='validationCustom03'
                      required
                      label='City'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-6' feedback='Please provide a valid zip.' invalid>
                    <MDBInput
                      value={formValue.zip}
                      name='zip'
                      onChange={onChange}
                      id='validationCustom05'
                      required
                      label='Zip'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-12' feedback='You must agree before submitting.' invalid>
                    <MDBCheckbox label='Agree to terms and conditions' id='invalidCheck' required />
                  </MDBValidationItem>
                  <div className='col-12'>
                    <MDBBtn type='submit'>Submit form</MDBBtn>
                    <MDBBtn type='reset'>Reset form</MDBBtn>
                  </div>
                </MDBValidation>
              );
            }
          
        
    

How it works

Here’s how form validation works with MDB:

  • HTML form validation is applied via CSS’s two pseudo-classes, :invalid and :valid. It applies to <input> and <textarea> elements.
  • MDB scopes the :invalid and :valid styles to parent .was-validated class, usually applied to the <form>. Otherwise, any required field without a value shows up as invalid on page load. This way, you may choose when to activate them (typically after form submission is attempted).
  • As a fallback, .is-invalid and .is-valid classes may be used instead of the pseudo-classes for server-side validation. They do not require a .was-validated parent class.
  • Due to constraints in how CSS works, we cannot (at present) apply styles to a <label> that comes before a form control in the DOM without the help of custom JavaScript.
  • All modern browsers support the constraint validation API, a series of JavaScript methods for validating form controls.
  • Feedback messages may utilize the browser defaults (different for each browser, and unstylable via CSS) or our custom feedback styles with additional HTML and CSS.
  • You may provide custom validity messages with setCustomValidity in JavaScript.

With that in mind, consider the following demos for our custom form validation styles, optional server-side classes, and browser defaults.


Browser defaults

Not interested in custom validation feedback messages or writing JavaScript to change form behaviors? All good, you can use the browser defaults. Try submitting the form below. Depending on your browser and OS, you’ll see a slightly different style of feedback.

While these feedback styles cannot be styled with CSS, you can still customize the feedback text through JavaScript.

@
        
            
            import React, { useState } from 'react';
            import { 
              MDBInput, 
              MDBBtn, 
              MDBCheckbox,
              MDBRow,
              MDBCol
            } from 'mdb-react-ui-kit';
    
            export default function App() {
              const [formValue, setFormValue] = useState({
                fname: 'Mark',
                lname: 'Otto',
                email: '',
                city: '',
                state: '',
                zip: '',
              });
            
              const onChange = (e: any) => {
                setFormValue({ ...formValue, [e.target.name]: e.target.value });
              };

              return (
                <MDBRow tag="form" className='g-3'>
                  <MDBCol md="4">
                    <MDBInput
                      value={formValue.fname}
                      name='fname'
                      onChange={onChange}
                      id='validationCustom01'
                      required
                      label='First name'
                    />
                  </MDBCol>
                  <MDBCol md="4">
                    <MDBInput
                      value={formValue.lname}
                      name='lname'
                      onChange={onChange}
                      id='validationCustom02'
                      required
                      label='Last name'
                    />
                  </MDBCol>
                  <MDBCol md="4">
                    <div className='input-group has-validation'>
                      <span className='input-group-text' id='inputGroupPrepend'>
                        @
                      </span>
                      <input
                        type='text'
                        className='form-control'
                        id='validationCustomUsername'
                        placeholder='Username'
                        required
                      />
                      <div className='invalid-feedback'>Please choose a username.</div>
                    </div>
                  </MDBCol>
                  <MDBCol md="6">
                    <MDBInput
                      value={formValue.city}
                      name='city'
                      onChange={onChange}
                      id='validationCustom03'
                      required
                      label='City'
                    />
                  </MDBCol>
                  <MDBCol md="6">
                    <MDBInput
                      value={formValue.zip}
                      name='zip'
                      onChange={onChange}
                      id='validationCustom05'
                      required
                      label='Zip'
                    />
                  </MDBCol>
                  <MDBCol size="12">
                    <MDBCheckbox label='Agree to terms and conditions' id='invalidCheck2' required />
                  </MDBCol>
                  <MDBCol size="12">
                    <MDBBtn type='submit'>Submit form</MDBBtn>
                  </MDBCol>
                </MDBRow>
              );
            }
          
        
    

Server side

We recommend using client-side validation, but in case you require server-side validation, you can indicate invalid and valid form fields with .is-invalid and .is-valid. Note that .invalid-feedback is also supported with these classes.

Looks good!
Looks good!
@
Please choose a username.
Please provide a valid city.
Please provide a valid zip.
You must agree before submitting.
        
            
            import React, { useState } from 'react';
            import { 
              MDBInput, 
              MDBInputGroup, 
              MDBBtn, 
              MDBCheckbox,
              MDBValidation,
              MDBValidationItem
            } from 'mdb-react-ui-kit';
    
            export default function App() {
              const [formValue, setFormValue] = useState({
                fname: 'Mark',
                lname: 'Otto',
                email: '',
                city: '',
                state: '',
                zip: '',
              });
            
              const onChange = (e: any) => {
                setFormValue({ ...formValue, [e.target.name]: e.target.value });
              };

              return (
                <MDBValidation className='row g-3' isValidated>
                  <MDBValidationItem className='col-md-4'>
                    <MDBInput
                      value={formValue.fname}
                      name='fname'
                      onChange={onChange}
                      id='validationCustom01'
                      required
                      label='First name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-4'>
                    <MDBInput
                      value={formValue.lname}
                      name='lname'
                      onChange={onChange}
                      id='validationCustom02'
                      required
                      label='Last name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem feedback='Please choose a username.' invalid className='col-md-4'>
                    <MDBInputGroup textBefore='@'>
                      <input
                        type='text'
                        className='form-control'
                        id='validationCustomUsername'
                        placeholder='Username'
                        required
                      />
                    </MDBInputGroup>
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-6' feedback='Please provide a valid city.' invalid>
                    <MDBInput
                      value={formValue.city}
                      name='city'
                      onChange={onChange}
                      id='validationCustom03'
                      required
                      label='City'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-md-6' feedback='Please provide a valid zip.' invalid>
                    <MDBInput
                      value={formValue.zip}
                      name='zip'
                      onChange={onChange}
                      id='validationCustom05'
                      required
                      label='Zip'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='col-12' feedback='You must agree before submitting.' invalid>
                    <MDBCheckbox label='Agree to terms and conditions' id='invalidCheck' required />
                  </MDBValidationItem>
                  <div className='col-12'>
                    <MDBBtn type='submit'>Submit form</MDBBtn>
                  </div>
                </MDBValidation>
              );
            }
          
        
    

Supported elements

Please enter a message in the textarea.
Example invalid feedback text
More example invalid feedback text
Example invalid form file feedback
        
            
            import React from 'react';
            import { 
              MDBInput, 
              MDBBtn, 
              MDBCheckbox,
              MDBTextArea,
              MDBRadio,
              MDBValidation,
              MDBValidationItem,
            } from 'mdb-react-ui-kit';
    
            export default function App() {
              return (
                <MDBValidation isValidated>
                  <MDBValidationItem className='mb-3 pb-1' feedback='Please enter a message in the textarea.' invalid>
                    <MDBTextArea
                      label='Textarea'
                      id='validationTextarea'
                      placeholder='Required example textarea'
                      required
                    />
                  </MDBValidationItem>
                  <MDBValidationItem className='mb-2 pb-1' invalid feedback='Example invalid feedback text.'>
                    <MDBCheckbox label='Check this checkbox' id='validationFormCheck1' required />
                  </MDBValidationItem>
                  <MDBRadio label='Toggle this radio' required id='validationFormCheck2' name='radio-stacked' />
                  <MDBValidationItem invalid feedback='More example invalid feedback text.'>
                    <MDBRadio
                      label='Or toggle this other radio'
                      required
                      id='validationFormCheck3'
                      name='radio-stacked'
                    />
                  </MDBValidationItem>
  
                  <MDBValidationItem
                    className='mt-3 mb-5'
                    feedback='Example invalid form file feedback'
                    invalid
                  >
                    <input type='file' className='form-control' aria-label='file example' required />
                  </MDBValidationItem>
                  <div>
                    <MDBBtn type='submit' disabled>
                      Submit form
                    </MDBBtn>
                  </div>
                </MDBValidation>
              );
            }
          
        
    

Tooltips

Add validationTooltip prop to display validation feedback in a styled tooltip. Be sure to have a parent with position: relative on it for tooltip positioning. In the example below, our column classes have this already, but your project may require an alternative setup.

Looks good!
Looks good!
@
Please choose a unique and valid username.
Please provide a valid city.
Please provide a valid zip.
        
            
            import React, { useState } from 'react';
            import { 
              MDBInput, 
              MDBInputGroup, 
              MDBBtn, 
              MDBCheckbox,
              MDBValidation,
              MDBValidationItem
            } from 'mdb-react-ui-kit';
    
            export default function App() {
              const [formValue, setFormValue] = useState({
                fname: 'Mark',
                lname: 'Otto',
                email: '',
                city: '',
                state: '',
                zip: '',
              });
            
              const onChange = (e: any) => {
                setFormValue({ ...formValue, [e.target.name]: e.target.value });
              };
              
              return (
                <MDBValidation className='row g-3'>
                  <MDBValidationItem tooltip className='col-md-4'>
                    <MDBInput
                      value={formValue.fname}
                      name='fname'
                      onChange={onChange}
                      id='validationCustom01'
                      required
                      label='First name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem tooltip className='col-md-4'>
                    <MDBInput
                      value={formValue.lname}
                      name='lname'
                      onChange={onChange}
                      id='validationCustom02'
                      required
                      label='Last name'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem tooltip feedback='Please choose a username.' invalid className='col-md-4'>
                    <MDBInputGroup textBefore='@'>
                      <input
                        type='text'
                        className='form-control'
                        id='validationCustomUsername'
                        placeholder='Username'
                        required
                      />
                    </MDBInputGroup>
                  </MDBValidationItem>
                  <MDBValidationItem tooltip className='col-md-6' feedback='Please provide a valid city.' invalid>
                    <MDBInput
                      value={formValue.city}
                      name='city'
                      onChange={onChange}
                      id='validationCustom03'
                      required
                      label='City'
                    />
                  </MDBValidationItem>
                  <MDBValidationItem tooltip className='col-md-6' feedback='Please provide a valid zip.' invalid>
                    <MDBInput
                      value={formValue.zip}
                      name='zip'
                      onChange={onChange}
                      id='validationCustom05'
                      required
                      label='Zip'
                    />
                  </MDBValidationItem>
                  <div className='col-12'>
                    <MDBBtn type='submit'>Submit form</MDBBtn>
                  </div>
                </MDBValidation>
              );
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Validation - API


Import

        
            
            import { MDBValidation } from 'mdb-react-ui-kit';
          
        
    

Properties

MDBValidation

Name Type Default Description Example
formRef React.MutableRefObject<any> false Reference to form element <MDBValidation formRef={reference} />
isValidated boolean false Set MDBValidation form validated <MDBValidation isValidated />

MDBValidationItem

Name Type Default Description Example
feedback React.ReactNode 'Looks good!' Feedback displayed on validation <MDBValidationItem feedback='Correct!' />
invalid boolean false Sets input validation to invalid mode <MDBValidationItem invalid />
tag string 'div' MDBValidationItem tag element <MDBValidationItem tag="span" />
tooltip boolean false Enables tooltip mode <MDBValidationItem tooltip />